================================================================================

Supplementary Haskell code for the Journal of Functional Programming article
"Programming Language Semantics: It's Easy As 1,2,3".

Graham Hutton

================================================================================

Syntax:

> data Expr = Val Integer | Add Expr Expr
>             deriving Show

Control stacks:

> data CONT = HALT | NEXT Expr CONT | ADD Integer CONT
>             deriving Show

Abstract machine:

> eval :: Expr -> Integer
> eval e = eval'' e HALT
>
> eval'' :: Expr -> CONT -> Integer
> eval'' (Val n)   c = exec c n
> eval'' (Add x y) c = eval'' x (NEXT y c)
>
> exec :: CONT -> Integer -> Integer
> exec HALT       n = n
> exec (NEXT y c) n = eval'' y (ADD n c)
> exec (ADD n c)  m = exec c (n+m)

================================================================================
